
#include "Modbus_Proto.h"
#include "main.h"


 
unsigned char Modbus_add;

#define MAX_MOD_REGISTERS 20
volatile unsigned short ModbusData[MAX_MOD_REGISTERS];

extern volatile uint16_t Modbus_timeout;
volatile uint8_t comtimeout=0;
volatile bool ready_to_answer;
char Buffer[40];
int _index;

void ModbusPrint(char Function,char * data,char len)
{

	int index2;
	unsigned short trCRC;

	if (len>12)return;
	
	_index=0;
	//Buffer[index++]=0; // Dummy For Transmitt Collision
	Buffer[_index++]=Modbus_add;
	Buffer[_index++]=Function;

    if ((Function==MOD_READ_HOLDING_REG)|| 
	    (Function==MOD_READ_INPUT_REG)|| 
	    (Function==MOD_READ_WRITE_MULTI_REG))
	Buffer[_index++]=len;

	for(index2=0;index2<len;index2+=2)
	{
		Buffer[_index++]=data[index2+1];
		Buffer[_index++]=data[index2];
	}

    if ((Function==MOD_READ_HOLDING_REG)|| 
	    (Function==MOD_READ_INPUT_REG)|| 
	    (Function==MOD_READ_WRITE_MULTI_REG))
	
	if ((_index<1)||(_index>30)) return;
	trCRC=CalcCRC16((uint8_t *)(&Buffer[0]),_index);
	Buffer[_index++]=trCRC&0xFF;
	Buffer[_index++]=trCRC>>8;
	ready_to_answer= true;
}


struct Proto{
	unsigned char ProtoState;
	unsigned char RecivePos;
    char Function;
	unsigned short ReadStartAddress;
	unsigned short QuantityToRead;
	unsigned short WriteStartAddress;
	unsigned short QuantityToWrite;
	unsigned short SingleWriteValue;

	unsigned short *rdCtrl;
	unsigned short *rdData;
	char rdbuffer[35];
    unsigned short Rtimeout;
 	unsigned short MBtimeout;
	char recLEN;
	unsigned short recdatalen;
	unsigned char datalen;

	unsigned short rec_CRC;
	unsigned short calc_CRC;
	unsigned char CRC_error;
}Proto;



#define MOD_READ_HOLDING_REG  0x03
#define MOD_READ_INPUT_REG    0x04
#define MOD_WRITE_SINGLE_REG  0x06
#define MOD_WRITE_MULTI_REG   0x10
#define MOD_READ_WRITE_MULTI_REG   0x17


void ModbusScan(unsigned char dat)
{	
int i;
	if (comtimeout>3)// Abruch wenn zwischen einem und dem anderen Byte eine Pause grer 3x500s autretet.
	{
			Proto.RecivePos=0;
			Proto.ProtoState=0;
	}
	comtimeout=0;

	if ((Proto.RecivePos>0)&&(Proto.RecivePos<30)) Proto.rdbuffer[Proto.RecivePos]=dat;
	Proto.RecivePos++;

	switch(Proto.ProtoState)
	{
		default:// recive Addess
			Proto.RecivePos=1;
			Proto.ProtoState=0;
			if (dat==Modbus_add)
			{	
				Proto.ProtoState=1;
			}

			Proto.rdbuffer[0]=dat;
			Proto.Rtimeout=2;
			break;
		case 1: // Get Function

			Proto.Function=dat;  //
			if ((Proto.Function==MOD_READ_HOLDING_REG)|| 	
				(Proto.Function==MOD_READ_INPUT_REG)|| 
				(Proto.Function==MOD_WRITE_SINGLE_REG)|| 
				(Proto.Function==MOD_WRITE_MULTI_REG)|| 
				(Proto.Function==MOD_READ_WRITE_MULTI_REG))
				Proto.ProtoState++;
				else Proto.RecivePos=0;
			break;
		case 2: // Start High READ_Start_ADRESS
			Proto.rdCtrl=(unsigned short *)&(Proto.rdbuffer[Proto.RecivePos-1]);
			Proto.ReadStartAddress=((unsigned short)dat)<<8;  // Start High
			Proto.ProtoState++;	
			if (dat!=0) Proto.ProtoState=0;
			break;
		case 3: // Start Low READ_Start_ADRESS
			Proto.ReadStartAddress|=((unsigned short)dat);  // Start Low
			Proto.ProtoState++;	
			break;
		case 4: // Quantity_to_read
			Proto.QuantityToRead=((unsigned short)dat)<<8; // Registers High 
			Proto.ProtoState++;	// DATALEN 
			if (dat!=0) Proto.ProtoState=0;
			break;
		case 5: // Quantity_to_read
			Proto.QuantityToRead|=((unsigned short)dat);  // Registers Low
			Proto.ProtoState++;	// DATALEN 
			if (Proto.QuantityToRead>=15) Proto.ProtoState=0;
			Proto.recdatalen=0;
			Proto.recLEN=Proto.RecivePos;//6

			if ((Proto.Function==MOD_READ_HOLDING_REG)||(Proto.Function==MOD_READ_INPUT_REG)||(Proto.Function==MOD_WRITE_SINGLE_REG))
			{
				Proto.ProtoState=100;
			}
			if (Proto.Function==MOD_WRITE_MULTI_REG)
			{
				Proto.WriteStartAddress=Proto.ReadStartAddress;
 				Proto.QuantityToWrite=Proto.QuantityToRead;
				Proto.ProtoState=10; // Get Recive Data
			}

			if (Proto.Function==MOD_WRITE_SINGLE_REG)
			{
				Proto.WriteStartAddress=Proto.ReadStartAddress;
 				Proto.SingleWriteValue=Proto.QuantityToRead;
			}
			break;
		case 6: // Write Start High
			
			Proto.WriteStartAddress=((unsigned short)dat)<<8;  // Start High
			Proto.ProtoState++;	
			if (dat!=0) Proto.ProtoState=0;

			break;
		case 7: // Write Start LOW
			Proto.WriteStartAddress|=((unsigned short)dat);  // Start Low
			Proto.ProtoState++;	
 			if (Proto.WriteStartAddress>=10) Proto.ProtoState=0;
			
			break;
		case 8: //Quantity_to_Whrite High
			Proto.QuantityToWrite=((unsigned short)dat)<<8; // Registers High 
			Proto.ProtoState++;	// DATALEN 
			if (dat!=0) Proto.ProtoState=0;
			 if (Proto.QuantityToWrite>=3) Proto.ProtoState=0;

			break;
		case 9: //Quantity_to_Whrite LOW
			Proto.QuantityToWrite|=((unsigned short)dat);  // Registers Low
			Proto.ProtoState++;	// DATALEN 
			break;
		case 10:// read data len
			Proto.datalen=dat;
			Proto.ProtoState++;
			Proto.recdatalen=0;
 			Proto.rdData=(unsigned short *)&(Proto.rdbuffer[Proto.RecivePos]);

		     if (Proto.datalen>=10) Proto.ProtoState=0;

			break;
		case 11:// read data
			Proto.recdatalen++;
			if (Proto.recdatalen>=Proto.datalen) Proto.ProtoState=100;
 			if (Proto.recdatalen>=10) Proto.ProtoState=0;
 			if (Proto.datalen>=10) Proto.ProtoState=0;
			break;
		case 100:	// CRC H
			Proto.rec_CRC=dat;
			Proto.ProtoState++;	
			break;
		case 101:	// CRC L
			Proto.rec_CRC+=((unsigned short)dat)<<8;
			Proto.calc_CRC=CalcCRC16((uint8_t *)Proto.rdbuffer,Proto.RecivePos-2);
			Proto.ProtoState=0;	// Reset
			Proto.RecivePos=0;	// Reset

			if (Proto.calc_CRC==Proto.rec_CRC)
			{
				Modbus_timeout=TIME_OUT_OFFLINE;
				if (Proto.Function==MOD_WRITE_SINGLE_REG) 
					if ((Proto.WriteStartAddress>=0)&&(Proto.WriteStartAddress<MAX_MOD_REGISTERS))
					{
						ModbusData[Proto.WriteStartAddress]=Proto.SingleWriteValue;
						ModbusPrint(Proto.Function,(char *)Proto.rdCtrl,4);
					}
				if ((Proto.Function==MOD_WRITE_MULTI_REG) || (Proto.Function==MOD_READ_WRITE_MULTI_REG))
				{
					if ((Proto.WriteStartAddress>=0)&&((Proto.WriteStartAddress+Proto.QuantityToWrite)<MAX_MOD_REGISTERS))
					{
						//Swaper(Proto.rdData,Proto.QuantityToWrite);
						for(i=0;i<Proto.QuantityToWrite;i++) 
						{
							ModbusData[Proto.WriteStartAddress+i]= Proto.rdData[i];
						}
						if (Proto.Function==MOD_WRITE_MULTI_REG) 
						{
							ModbusPrint(Proto.Function,(char *)Proto.rdCtrl,4);
						}
					}
				}
				if ((Proto.Function==MOD_READ_HOLDING_REG)|| 	
					(Proto.Function==MOD_READ_INPUT_REG)|| 
					(Proto.Function==MOD_READ_WRITE_MULTI_REG))
				{
					ModbusData[10]++;
					if (Proto.QuantityToRead<=MAX_MOD_REGISTERS) 
					{
						ModbusPrint(Proto.Function,(char *)&ModbusData[Proto.ReadStartAddress],Proto.QuantityToRead*2);
					}
				}
			} 
			else
			{
				Proto.CRC_error++;	
			}
			break;

	}	


}



