/*
 * main.c
 *
 * Created: 10.04.2017 20:18:56
 * Author : CLEVO
 */ 

#include "main.h"

//FUSES =
//{
	//.low = 0xd6,
	//.high = 0x99,
	//.extended = 0xff,
//};

//const char fusedata[] __attribute__ ((section(".fuse")))= {0xff, 0x91, 0xff};

uint16_t ReverseBytes(uint16_t value);
void ComWrite(unsigned char * data,unsigned char  len);

uint16_t Map_In(void);
void Map_Out(uint16_t Out);

bool operational = false,master_da=false;

volatile uint16_t debughelp;

uint8_t ADDRESS;
 
 volatile uint8_t protoflagSlave0_U0,protoflagSlave1_U0;
 
volatile uint16_t analog_row[3];
 volatile uint8_t protoflag_1;
 volatile uint8_t protoflag_conf;
volatile int16_t target_temp,target_voltage;
 
 volatile uint32_t runtime;
volatile uint8_t answer_delay;

unsigned short wDevice_SVers=200;
volatile uint16_t Modbus_timeout;

int main(void)
{
 
	/* I/O Config */
	DDRA	|= (1<<Out_4);  // Set as output
	PORTA	|= (1<<IN_State_BTS3_4	) | (1<<IN_Valve_open) | (1<<IN_Valve_close) | (1<<IN_Valve_ok) | (1<<IN_Valve_center); // Enable Pullup
	
	DDRB	|= (1<<OUT_RUNLED); // Set as output
	PORTB	|= (1<<IN_Hex2) | (1<<IN_Hex8) | (1<<IN_Hex4) | (1<<IN_Hex1) | (1<<IN_SW_CW) | (1<<IN_SW_CCW) | (1<<IN_SW_ZU); // Enable Pullup
	
	
	DDRD	|= (1<<OUT_Enable485) | (1<<Out_3) | (1<<Out_2) | (1<<Out_1); // Set as output
	PORTD	|= (1<<IN_SW_AUF) | (1<<IN_State_BTS1_2); // Enable Pullup
	
	uart_init( UART_BAUD_SELECT(UART0_BAUD_RATE,F_CPU) );
	UCSR0B |=(1<<TXCIE0);
	//uart1_init( UART_BAUD_SELECT(UART1_BAUD_RATE,F_CPU) );
	
	// Timer0 config
	OCR0A = (uint8_t)(int16_t)((F_CPU / 64 * 50e-5 + 0.5)-1);	// preload for 500s
	TCCR0A |= (1<<WGM01);					//CTC Mode
	TCCR0B |= (1<<CS01) |(1<<CS00);
	TIMSK0 |= (1<<OCIE0A);										// enable timer Compare A Interrupt
	
	// ADC config
	ADMUX |=	(1<<REFS0);										//AVCC with external capacitor on AREF pin
	ADCSRA |=	(1<<ADEN)  |(1<<ADSC)|(1<<ADATE)| (1<<ADIE);	// Enable Adc
	ADCSRA |=	(1<<ADPS2) |(1<<ADPS1) |(1<<ADPS0);
	
	sei();
	
	ModbusData[STATUS_WORD]=0; // State Word
	ModbusData[CONTROL_WORD]=0; // Control Word
	ModbusData[RUNTIME]=0; // Run time
	ModbusData[SOFTWARE_VERSION]=wDevice_SVers;
	ModbusData[TARGET_VOLTAGE]=0; // Target Voltage
	ModbusData[TARGET_TEMPERATUR]=0; // Target Temperatur
	
	if (!(PINB &(1<<IN_Hex1)))			Modbus_add|=0x01;
	if (!(PINB &(1<<IN_Hex2)))			Modbus_add|=0x02;
	if (!(PINB &(1<<IN_Hex4)))			Modbus_add|=0x04;
	if (!(PINB &(1<<IN_Hex8)))			Modbus_add|=0x08;
	Modbus_add +=10;
	wdt_enable(WDTO_500MS);
    while (1) 
    {
		wdt_reset();		// RESET WATCHDOG
		//uart_puts("HALLO_Seik\n\r");
		if (ready_to_answer)
		{
			if (answer_delay==0)
			{
				ComWrite((unsigned char *)Buffer, _index);
				ready_to_answer=false;
			}
		}
		else
		{
			answer_delay=8;
		}
		
		ModbusData[STATUS_WORD]=Map_In();
		ModbusData[TARGET_VOLTAGE]=voltage_calc(analog_row[ROW_VOLTAGE_TARGET]);
		
		ModbusData[TARGET_TEMPERATUR]=calcTemp(analog_row[ROW_TEMP_TARGET]);	// Temperatur von MCP700
		//
		
		if (Modbus_timeout==0)
		{ // Fail Mode
			operational=false;
			if (!(PIND & (1<<IN_SW_AUF))) 
			{
				Map_Out(1); 
			}
			else if (!(PINB & (1<<IN_SW_ZU)))
			{
				Map_Out(2); 
			}
			else
			{
				 Map_Out(0);
			}
		}
		else
		{
			uint16_t data_swap;
			data_swap=ReverseBytes(ModbusData[CONTROL_WORD]);
			Map_Out(data_swap);
			operational=true;
		}
    } // END_While_Loop
}// END Main_Loop

ISR(USART0_TX_vect)
{
	PORTD	&= ~(1<<OUT_Enable485);		// RS485 Sender ausschalten!
}


ISR(TIMER0_COMPA_vect)	//_evry 500S Interrupt
{
	static uint16_t run=2000 ,sec=5000,Tic100ms=200;
	
	comtimeout++;
	run--;
	answer_delay--;
	if(run==0)
	{
		if(operational) run=200; else run=2000;
		PORTB ^=(1<<OUT_RUNLED);
		
	}
	if(--Tic100ms==0)
	{
		ModbusData[2]++; // Runtime.........
		Tic100ms=200;
		if (Modbus_timeout>0) 
		{
			Modbus_timeout--;
		}
		
	}
	if(--sec==0)
	{
		sec=2000;
		
	}
}



void ComWrite(unsigned char * data,unsigned char  len)
{
	unsigned char i;
	for(i=0;i<len;i++)
	{
		uart_putc(data[i]);
	}
}

ISR(ADC_vect)  // Alle 100S eine Messung
{
	static uint32_t adc_sum;
	static uint8_t count;
	static uint8_t plexer=0;
	
	adc_sum += ADC;
	count++;
	ADCSRA |= (1<<ADSC);
	if( count == 16 )  
	{
		count=0;
		analog_row[plexer] = ADC;//(adc_sum >> 4);		// average over 16 samples
		adc_sum =0;
		ADMUX |=(1<<0);
		plexer++;
		if(plexer==2)
		{
			ADMUX &=~(1<<0);
			plexer=0;
		}
	}
}


//**********************************************************************************************************************************************************************************************

void Map_Out(uint16_t Out)
{
	
	
	if (Out<=2)
	{
		if (Out==1) // Ventil ffnen
		{ 
			 if ( (!(PINB & (1<<IN_SW_CW))) || (PINB & (1<<IN_SW_CCW)))
			 {
				 PORTD |= (1<<Out_1)| (1<<Out_2);
				 PORTD &= ~(1<<Out_3);PORTA &= ~(1<<Out_4);
			 }
			 if (!(PINB & (1<<IN_SW_CCW)))
			 {
				 PORTD |= (1<<Out_3);PORTA |= (1<<Out_4);
				 PORTD &= ~(1<<Out_1); PORTD &= ~(1<<Out_2);
			 }
		}
		if (Out==2) // ventil schlieen
		{
			if (!(PINB & (1<<IN_SW_CCW)))
			{
				PORTD |= (1<<Out_1)| (1<<Out_2);
				PORTD &= ~(1<<Out_3);PORTA &= ~(1<<Out_4);
			}
			if ( (!(PINB & (1<<IN_SW_CW))) || (PINB & (1<<IN_SW_CCW)))
			{
				PORTD |= (1<<Out_3);PORTA |= (1<<Out_4);
				PORTD &= ~(1<<Out_1); PORTD &= ~(1<<Out_2);
			}
		} 
		if (Out==0)
		{ 
			PORTA &= ~(1<<Out_4);
			PORTD &= ~(1<<Out_1);
			PORTD &= ~(1<<Out_2);
			PORTD &= ~(1<<Out_3);
		}
	}
	else
	{
		if (Out&(1<<2))  PORTD |= (1<<Out_1); else PORTD &= ~(1<<Out_1);
		if (Out&(1<<3))  PORTD |= (1<<Out_2); else PORTD &= ~(1<<Out_2);
		if (Out&(1<<4))	 PORTD |= (1<<Out_3); else PORTD &= ~(1<<Out_3);
		if (Out&(1<<5))	 PORTA |= (1<<Out_4); else PORTA &= ~(1<<Out_4);
	}

}

uint16_t Map_In(void)
{
	unsigned short in=0;
	
	//Valv Inputs
	if (!(PINA &(1<<IN_Valve_open)))
	{
		if ( (!(PINB & (1<<IN_SW_CW))) || (PINB & (1<<IN_SW_CCW)))
		{
			in|= (1<<0);
		}
		if (!(PINB & (1<<IN_SW_CCW)))
		{
			in|= (1<<1);
		}
	}
	if (!(PINA &(1<<IN_Valve_close)))
	{
		if ( (!(PINB & (1<<IN_SW_CW))) || (PINB & (1<<IN_SW_CCW)))
		{
			in|= (1<<1);
		}
		if (!(PINB & (1<<IN_SW_CCW)))
		{
			in|= (1<<0);
		}
	}
	if (!(PINA &(1<<IN_Valve_ok)))			in|= (1<<2);
	if (!(PINA &(1<<IN_Valve_center)))		in|= (1<<3);

	// Fail Switch
	if (!(PINB &(1<<IN_SW_CW)))				in|= (1<<4);
	if (!(PINB &(1<<IN_SW_CCW)))			in|= (1<<5);

	// Bts State
	if (!(PINA &(1<<IN_State_BTS3_4)))	in|= (1<<6);
	if (!(PIND &(1<<IN_State_BTS1_2)))	in|= (1<<7);	

	 //Addres Switch
	if (!(PINB &(1<<IN_Hex1)))			in|=0x0100;
	if (!(PINB &(1<<IN_Hex2)))			in|=0x0200;
	if (!(PINB &(1<<IN_Hex4)))			in|=0x0400;
	if (!(PINB &(1<<IN_Hex8)))			in|=0x0800;
	
	// open/close Switch
	if (!(PIND &(1<<IN_SW_AUF)))		in|=0x1000;
	if (!(PINB &(1<<IN_SW_ZU)))			in|=0x2000;

	return(in);
}

uint16_t ReverseBytes(uint16_t value)
    {
        return ((value & 0xFFU) << 8 | (value & 0xFF00U) >> 8);
    }



//************************************************************************************************************************************************************************************************
